Index: /extensions/SmartAlbums/admin.php
===================================================================
--- /extensions/SmartAlbums/admin.php	(revision 26441)
+++ /extensions/SmartAlbums/admin.php	(revision 26442)
@@ -1,4 +1,4 @@
 <?php
-if (!defined('PHPWG_ROOT_PATH')) die('Hacking attempt!');
+defined('SMART_PATH') or die('Hacking attempt!');
 
 global $conf, $template, $page;
@@ -25,4 +25,2 @@
 
 $template->assign_var_from_handle('ADMIN_CONTENT', 'SmartAlbums_content');
-
-?>
Index: /extensions/SmartAlbums/admin/album.php
===================================================================
--- /extensions/SmartAlbums/admin/album.php	(revision 26441)
+++ /extensions/SmartAlbums/admin/album.php	(revision 26442)
@@ -1,26 +1,4 @@
 <?php
-// +-----------------------------------------------------------------------+
-// | Piwigo - a PHP based photo gallery                                    |
-// +-----------------------------------------------------------------------+
-// | Copyright(C) 2008-2012 Piwigo Team                  http://piwigo.org |
-// | Copyright(C) 2003-2008 PhpWebGallery Team    http://phpwebgallery.net |
-// | Copyright(C) 2002-2003 Pierrick LE GALL   http://le-gall.net/pierrick |
-// +-----------------------------------------------------------------------+
-// | This program is free software; you can redistribute it and/or modify  |
-// | it under the terms of the GNU General Public License as published by  |
-// | the Free Software Foundation                                          |
-// |                                                                       |
-// | This program is distributed in the hope that it will be useful, but   |
-// | WITHOUT ANY WARRANTY; without even the implied warranty of            |
-// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU      |
-// | General Public License for more details.                              |
-// |                                                                       |
-// | You should have received a copy of the GNU General Public License     |
-// | along with this program; if not, write to the Free Software           |
-// | Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, |
-// | USA.                                                                  |
-// +-----------------------------------------------------------------------+
-
-if(!defined("PHPWG_ROOT_PATH")) die ("Hacking attempt!");
+defined('SMART_PATH') or die('Hacking attempt!');
 
 // +-----------------------------------------------------------------------+
@@ -33,12 +11,13 @@
 
 check_input_parameter('cat_id', $_GET, false, PATTERN_ID);
-
-$admin_album_base_url = get_root_url().'admin.php?page=album-'.$_GET['cat_id'];
-$self_url = SMART_ADMIN.'-album&amp;cat_id='.$_GET['cat_id'];
+$cat_id = $_GET['cat_id'];
+
+$admin_album_base_url = get_root_url().'admin.php?page=album-'.$cat_id;
+$self_url = SMART_ADMIN.'-album&amp;cat_id='.$cat_id;
 
 $query = '
 SELECT *
   FROM '.CATEGORIES_TABLE.'
-  WHERE id = '.$_GET['cat_id'].'
+  WHERE id = '.$cat_id.'
 ;';
 $category = pwg_db_fetch_assoc(pwg_query($query));
@@ -48,4 +27,11 @@
   die("unknown album");
 }
+
+// category must be virtual
+if ($category['dir'] != NULL)
+{
+  die("physical album");
+}
+
 
 // +-----------------------------------------------------------------------+
@@ -60,12 +46,4 @@
 
 
-$cat_id = $_GET['cat_id'];
-
-// category must be virtual
-if ($category['dir'] != NULL)
-{
-  die("physical album");
-}
-
 // +-----------------------------------------------------------------------+
 // | Save Filters                                                          |
@@ -78,31 +56,34 @@
     var_dump($_POST['filters']);
   }
-  
+
   // test if it was a Smart Album
   $query = '
-SELECT DISTINCT category_id 
-  FROM '.CATEGORY_FILTERS_TABLE.' 
+SELECT DISTINCT category_id
+  FROM '.CATEGORY_FILTERS_TABLE.'
   WHERE category_id = '.$cat_id.'
 ;';
   $was_smart = pwg_db_num_rows(pwg_query($query));
-  
+
   /* this album is no longer a SmartAlbum */
-  if ( $was_smart AND !isset($_POST['is_smart']) )
+  if ($was_smart and !isset($_POST['is_smart']))
   {
     pwg_query('DELETE FROM '.IMAGE_CATEGORY_TABLE.' WHERE category_id = '.$cat_id.' AND smart = true;');
     pwg_query('DELETE FROM '.CATEGORY_FILTERS_TABLE.' WHERE category_id = '.$cat_id.';');
+
     set_random_representant(array($cat_id));
+
+    define('SMART_NOT_UPDATE', 1);
     invalidate_user_cache();
   }
   /* no filter selected */
-  else if ( isset($_POST['is_smart']) AND empty($_POST['filters']) )
-  {
-    array_push($page['errors'], l10n('No filter selected'));
+  else if (isset($_POST['is_smart']) and empty($_POST['filters']))
+  {
+    $page['errors'][] = l10n('No filter selected');
   }
   /* everything is fine */
-  else if ( isset($_POST['is_smart']) )
+  else if (isset($_POST['is_smart']))
   {
     pwg_query('DELETE FROM '.CATEGORY_FILTERS_TABLE.' WHERE category_id = '.$cat_id.';');
-    
+
     $inserts = array();
     foreach ($_POST['filters'] as $filter)
@@ -114,17 +95,17 @@
       }
     }
-    
+
     mass_inserts(
-      CATEGORY_FILTERS_TABLE, 
-      array('category_id', 'type', 'cond', 'value'), 
+      CATEGORY_FILTERS_TABLE,
+      array('category_id', 'type', 'cond', 'value'),
       $inserts,
       array('ignore'=>true)
       );
-    
+
     $associated_images = smart_make_associations($cat_id);
     $template->assign('IMAGE_COUNT', l10n_dec('%d photo', '%d photos', count($associated_images)));
-    
-    array_push($page['infos'], sprintf(l10n('%d photos associated to album %s'), count($associated_images), ''));
-    
+
+    $page['infos'][] = l10n('%d photos associated to album %s', count($associated_images), '');
+
     define('SMART_NOT_UPDATE', 1);
     invalidate_user_cache();
@@ -225,9 +206,9 @@
 /* get filters for this album */
 $query = '
-SELECT * 
-  FROM '.CATEGORY_FILTERS_TABLE.' 
+SELECT *
+  FROM '.CATEGORY_FILTERS_TABLE.'
   WHERE category_id = '.$cat_id.'
-  ORDER BY 
-    type ASC, 
+  ORDER BY
+    type ASC,
     cond ASC
 ;';
@@ -250,7 +231,7 @@
   WHERE id IN('.$filter['value'].')
 ;';
-    $filter['value'] = get_taglist($query); 
-  }
-  
+    $filter['value'] = get_taglist($query);
+  }
+
   $template->append('filters', $filter);
 }
@@ -260,5 +241,5 @@
 $template->assign('format_options', array(
   'portrait' => l10n('Portrait'),
-  'square'   => l10n('Square'),
+  'square'   => l10n('square'),
   'lanscape' => l10n('Landscape'),
   'panorama' => l10n('Panorama'),
@@ -274,8 +255,8 @@
 /* all albums */
 $query = '
-SELECT 
-    id, 
-    name, 
-    uppercats, 
+SELECT
+    id,
+    name,
+    uppercats,
     global_rank
   FROM '.CATEGORIES_TABLE.'
@@ -303,7 +284,10 @@
 while ($row = pwg_db_fetch_assoc($result))
 {
-  $widths[] = $row['width'];
-  $heights[] = $row['height'];
-  $ratios[] = floor($row['width'] * 100 / $row['height']) / 100;
+  if ($row['width']>0 && $row['height']>0)
+  {
+    $widths[] = $row['width'];
+    $heights[] = $row['height'];
+    $ratios[] = floor($row['width'] / $row['height'] * 100) / 100;
+  }
 }
 
@@ -354,11 +338,11 @@
 }
 
-foreach (array_keys($ratio_categories) as $ratio_category)
-{
-  if (count($ratio_categories[$ratio_category]) > 0)
-  {
-    $dimensions['ratio_'.$ratio_category] = array(
-      'min' => $ratio_categories[$ratio_category][0],
-      'max' => $ratio_categories[$ratio_category][count($ratio_categories[$ratio_category]) - 1]
+foreach ($ratio_categories as $ratio_name => $ratio_values)
+{
+  if (count($ratio_values) > 0)
+  {
+    $dimensions['ratio_'.$ratio_name] = array(
+      'min' => $ratio_values[0],
+      'max' => array_pop($ratio_values),
       );
   }
@@ -371,8 +355,8 @@
 {
   $query = '
-SELECT count(1) 
-  FROM '.IMAGE_CATEGORY_TABLE.' 
-  WHERE 
-    category_id = '.$cat_id.' 
+SELECT count(1)
+  FROM '.IMAGE_CATEGORY_TABLE.'
+  WHERE
+    category_id = '.$cat_id.'
     AND smart = true
 ';
@@ -396,5 +380,3 @@
 ));
 
-$template->set_filename('SmartAlbums_content', dirname(__FILE__).'/template/album.tpl');
-
-?>
+$template->set_filename('SmartAlbums_content', realpath(SMART_PATH . 'admin/template/album.tpl'));
Index: /extensions/SmartAlbums/admin/cat_list.php
===================================================================
--- /extensions/SmartAlbums/admin/cat_list.php	(revision 26441)
+++ /extensions/SmartAlbums/admin/cat_list.php	(revision 26442)
@@ -1,4 +1,4 @@
 <?php
-if (!defined('PHPWG_ROOT_PATH')) die('Hacking attempt!');
+defined('SMART_PATH') or die('Hacking attempt!');
 
 if (isset($_GET['hide_messages']))
@@ -16,5 +16,5 @@
 $categories = array();
 $query = '
-SELECT 
+SELECT
     id,
     name,
@@ -51,5 +51,5 @@
   if (isset($output_create['error']))
   {
-    array_push($page['errors'], $output_create['error']);
+    $page['errors'][] = $output_create['error'];
   }
   else
@@ -69,9 +69,9 @@
     {
       $associated_images = smart_make_associations($category['id']);
-      array_push($page['infos'], 
-        sprintf(l10n('%d photos associated to album %s'), 
-          count($associated_images), 
-          '&laquo;'.trigger_event('render_category_name', $category['name'], 'admin_cat_list').'&raquo;'
-          )
+
+      $page['infos'][] = l10n(
+        '%d photos associated to album %s',
+        count($associated_images),
+        '&laquo;'.trigger_event('render_category_name', $category['name'], 'admin_cat_list').'&raquo;'
         );
     }
@@ -80,13 +80,13 @@
   else
   {
-    $associated_images = smart_make_associations($_GET['smart_generate']);    
-    array_push($page['infos'], 
-      sprintf(l10n('%d photos associated to album %s'), 
-        count($associated_images), 
-        '&laquo;'.trigger_event('render_category_name', $categories[ $_GET['smart_generate'] ]['name'], 'admin_cat_list').'&raquo;'
-        )
+    $associated_images = smart_make_associations($_GET['smart_generate']);
+
+    $page['infos'][] = l10n(
+      '%d photos associated to album %s',
+      count($associated_images),
+      '&laquo;'.trigger_event('render_category_name', $categories[ $_GET['smart_generate'] ]['name'], 'admin_cat_list').'&raquo;'
       );
   }
-  
+
   define('SMART_NOT_UPDATE', 1);
   invalidate_user_cache();
@@ -100,5 +100,5 @@
   'PWG_TOKEN' => get_pwg_token(),
  ));
- 
+
 // retrieve all existing categories for album creation
 $query = '
@@ -108,14 +108,13 @@
 
 display_select_cat_wrapper(
-  $query,
-  null,
+  $query, null,
   'category_options'
   );
-  
+
 if ($conf['SmartAlbums']['show_list_messages'])
 {
-  array_push($page['warnings'], l10n('Only SmartAlbums are displayed on this page'));
-  array_push($page['warnings'], sprintf(l10n('To order albums please go the main albums <a href="%s">management page</a>'), $base_url.'cat_list'));
-  array_push($page['warnings'], '<a href="'.$self_url.'&hide_messages">['.l10n('Don\'t show this message again').']</a>');
+  $page['warnings'][] = l10n('Only SmartAlbums are displayed on this page');
+  $page['warnings'][] = sprintf(l10n('To order albums please go the main albums <a href="%s">management page</a>'), $base_url.'cat_list');
+  $page['warnings'][] = '<a href="'.$self_url.'&hide_messages">['.l10n('Don\'t show this message again').']</a>';
 }
 
@@ -125,9 +124,9 @@
 
 $categories_count_images = array();
-if ( count($categories) )
+if (count($categories))
 {
   $query = '
-SELECT 
-    category_id, 
+SELECT
+    category_id,
     COUNT(image_id) AS total_images
   FROM '.IMAGE_CATEGORY_TABLE.'
@@ -154,9 +153,7 @@
       'U_SMART'     => $self_url.'&amp;smart_generate='.$category['id'],
     );
-  
+
   $template->append('categories', $tpl_cat);
 }
 
-$template->set_filename('SmartAlbums_content', dirname(__FILE__).'/template/cat_list.tpl');
-
-?>
+$template->set_filename('SmartAlbums_content', realpath(SMART_PATH . 'admin/template/cat_list.tpl'));
Index: /extensions/SmartAlbums/admin/config.php
===================================================================
--- /extensions/SmartAlbums/admin/config.php	(revision 26441)
+++ /extensions/SmartAlbums/admin/config.php	(revision 26442)
@@ -1,14 +1,13 @@
 <?php
-if (!defined('PHPWG_ROOT_PATH')) die('Hacking attempt!');
+defined('SMART_PATH') or die('Hacking attempt!');
 
-// Enregistrement de la configuration
 if (isset($_POST['submit']))
 {
-  if ( $_POST['update_timeout'] == 0 or !preg_match('#^[0-9.]+$#', $_POST['update_timeout']) )
+  if ($_POST['update_timeout'] == 0 or !preg_match('#^[0-9.]+$#', $_POST['update_timeout']))
   {
-    array_push($page['errors'], l10n('Invalid number of days'));
+    $page['errors'][] = l10n('Invalid number of days');
     $_POST['update_timeout'] = $conf['SmartAlbums']['update_timeout'];
   }
-    
+
   $conf['SmartAlbums'] = array(
     'show_list_messages' => $conf['SmartAlbums']['show_list_messages'],
@@ -19,12 +18,10 @@
     'smart_is_forbidden' => isset($_POST['smart_is_forbidden']),
     );
-  
+
   conf_update_param('SmartAlbums', serialize($conf['SmartAlbums']));
-  array_push($page['infos'], l10n('Information data registered in database'));
+  $page['infos'][] = l10n('Information data registered in database');
 }
 
 $template->assign($conf['SmartAlbums']);
 
-$template->set_filename('SmartAlbums_content', dirname(__FILE__).'/template/config.tpl');
-
-?>
+$template->set_filename('SmartAlbums_content', realpath(SMART_PATH . 'admin/template/config.tpl'));
Index: /extensions/SmartAlbums/include/count_images.php
===================================================================
--- /extensions/SmartAlbums/include/count_images.php	(revision 26441)
+++ /extensions/SmartAlbums/include/count_images.php	(revision 26442)
@@ -10,5 +10,5 @@
 include_once(PHPWG_ROOT_PATH.'admin/include/functions.php');
 
-if (!is_admin()) die('Hacking attempt!');
+is_admin() or die('Hacking attempt!');
 
 
@@ -18,14 +18,14 @@
   $page['errors'] = array();
   $limit_is_set = false;
-  
+
   foreach ($_POST['filters'] as $filter)
   {
     if (($filter = smart_check_filter($filter)) != false)
     {
-      array_push($filters, $filter);
+      $filters[] = $filter;
     }
     else
     {
-      echo '<span class="filter_error">'.$page['errors'][ count($page['errors'])-1 ].'</span>';
+      echo '<span class="filter_error">'. array_pop($page['errors']) .'</span>';
       exit;
     }
Index: /extensions/SmartAlbums/include/events.inc.php
===================================================================
--- /extensions/SmartAlbums/include/events.inc.php	(revision 26442)
+++ /extensions/SmartAlbums/include/events.inc.php	(revision 26442)
@@ -0,0 +1,129 @@
+<?php
+defined('SMART_PATH') or die('Hacking attempt!');
+
+/**
+ * clean table when categories are deleted
+ */
+function smart_delete_categories($ids)
+{
+  $query = '
+DELETE FROM '.CATEGORY_FILTERS_TABLE.'
+  WHERE category_id IN('.implode(',', $ids).')
+;';
+  pwg_query($query);
+}
+
+/**
+ * update images list periodically
+ */
+function smart_periodic_update()
+{
+  global $conf;
+
+  // we only search for old albums every hour, nevermind which user is connected
+  if ($conf['SmartAlbums']['last_update'] > time() - 3600) return;
+
+  $conf['SmartAlbums']['last_update'] = time();
+  conf_update_param('SmartAlbums', serialize($conf['SmartAlbums']));
+
+  // get categories with smart filters
+  $query = '
+SELECT DISTINCT category_id
+  FROM '.CATEGORY_FILTERS_TABLE.'
+  WHERE updated < DATE_SUB(NOW(), INTERVAL '.$conf['SmartAlbums']['update_timeout'].' DAY)
+;';
+
+  // regenerate photo list
+  $smart_cats = query2array($query, null, 'category_id');
+  array_map('smart_make_associations', $smart_cats);
+}
+
+/**
+ * Remove picture that must not be displayed from $page['items']
+ *
+ * here we get all pictures that current user could see
+ * if SmartAlbums doesn't exist, and make intersect with pictures
+ * actually displayed
+ */
+function smart_init_page_items()
+{
+  global $user, $page, $conf;
+
+  if (
+    ('categories' == $page['section']) and
+    (!isset($page['chronology_field'])) and
+    (
+      (isset($page['category'])) or
+      (isset($page['flat']))
+    )
+  ) {
+
+    $query = '
+SELECT DISTINCT category_id
+  FROM '.CATEGORY_FILTERS_TABLE.'
+;';
+    $smart_albums = query2array($query, null, 'category_id');
+
+    if (count($smart_albums) > 0 and !is_admin())
+    {
+      // add SmartAlbums to forbidden categories
+      $user['forbidden_categories_old'] = $user['forbidden_categories'];
+      $user['forbidden_categories'] = explode(',', $user['forbidden_categories']);
+      $user['forbidden_categories'] = array_unique(array_merge($user['forbidden_categories'], $smart_albums));
+      $user['forbidden_categories'] = implode(',', $user['forbidden_categories']);
+
+      if (isset($page['category']))
+      {
+        $query = '
+SELECT id
+  FROM '.CATEGORIES_TABLE.'
+  WHERE
+    '.get_sql_condition_FandF(
+      array(
+        'forbidden_categories' => 'id',
+        'visible_categories' => 'id',
+        )
+      );
+        $subcat_ids = query2array($query, null, 'id');
+        $subcat_ids[] = 0;
+        $where_sql = 'category_id IN ('.implode(',',$subcat_ids).')';
+        // remove categories from forbidden because just checked above
+        $forbidden = get_sql_condition_FandF(
+          array(
+            'visible_images' => 'id'
+            ),
+          'AND'
+          );
+      }
+      else
+      {
+        $where_sql = '1=1';
+        $forbidden = get_sql_condition_FandF(
+          array(
+            'forbidden_categories' => 'category_id',
+            'visible_categories' => 'category_id',
+            'visible_images' => 'id'
+            ),
+          'AND'
+          );
+      }
+
+      // Main query
+      $query = '
+SELECT DISTINCT(image_id)
+  FROM '.IMAGE_CATEGORY_TABLE.'
+    INNER JOIN '.IMAGES_TABLE.' ON id = image_id
+  WHERE
+    '.$where_sql.'
+'.$forbidden.'
+  '.$conf['order_by'].'
+;';
+
+      $page['items_wo_sa'] = query2array($query, null, 'image_id');
+      $page['items'] = array_intersect($page['items'], $page['items_wo_sa']);
+
+      // restore forbidden categories
+      $user['forbidden_categories'] = $user['forbidden_categories_old'];
+    }
+  }
+}
Index: /extensions/SmartAlbums/include/events_admin.inc.php
===================================================================
--- /extensions/SmartAlbums/include/events_admin.inc.php	(revision 26442)
+++ /extensions/SmartAlbums/include/events_admin.inc.php	(revision 26442)
@@ -0,0 +1,143 @@
+<?php
+defined('SMART_PATH') or die('Hacking attempt!');
+
+/**
+ * new tab on album properties page
+ */
+function smart_tab($sheets, $id)
+{
+  if ($id == 'album')
+  {
+    global $category;
+
+    if ($category['dir'] == null)
+    {
+      $sheets['smartalbum'] = array(
+        'caption' => 'SmartAlbum',
+        'url' => SMART_ADMIN.'-album&amp;cat_id='.$_GET['cat_id'],
+        );
+    }
+  }
+
+  return $sheets;
+}
+
+/**
+ * admin plugins menu link
+ */
+function smart_admin_menu($menu)
+{
+  $menu[] = array(
+    'NAME' => 'SmartAlbums',
+    'URL' => SMART_ADMIN,
+    );
+  return $menu;
+}
+
+/**
+ * Add a link into categories list to regenerate associations
+ */
+function smart_cat_list()
+{
+  global $template, $page;
+
+  if (!isset($smart_count))
+  {
+    $smart_count = 0;
+  }
+
+  $self_url = get_root_url().'admin.php?page=cat_list'.(isset($_GET['parent_id']) ? '&amp;parent_id='.$_GET['parent_id'] : null);
+
+  /* get categories with smart filters */
+  $query = '
+SELECT DISTINCT id, name
+  FROM '.CATEGORIES_TABLE.' AS c
+    INNER JOIN '.CATEGORY_FILTERS_TABLE.' AS cf
+    ON c.id = cf.category_id';
+  if (!isset($_GET['parent_id']))
+  {
+    // $query.= '
+    // WHERE id_uppercat IS NULL';
+  }
+  else
+  {
+    $query .= '
+  WHERE uppercats LIKE \'%'.$_GET['parent_id'].'%\'';
+  }
+  $query .= '
+;';
+
+  $smart_cats = query2array($query, 'id');
+
+  if (isset($_GET['smart_generate']))
+  {
+    /* regenerate photo list | all (sub) categories */
+    if ($_GET['smart_generate'] == 'all')
+    {
+      foreach ($smart_cats as $category)
+      {
+        $associated_images = smart_make_associations($category['id']);
+
+        $page['infos'][] = l10n(
+          '%d photos associated to album %s',
+          count($associated_images),
+          '&laquo;'.trigger_event('render_category_name', $category['name'], 'admin_cat_list').'&raquo;'
+          );
+      }
+    }
+    /* regenerate photo list | one category */
+    else
+    {
+      $associated_images = smart_make_associations($_GET['smart_generate']);
+
+      $page['infos'][] = l10n(
+        '%d photos associated to album %s',
+        count($associated_images),
+        '&laquo;'.trigger_event('render_category_name', $smart_cats[ $_GET['smart_generate'] ]['name'], 'admin_cat_list').'&raquo;'
+        );
+    }
+
+    define('SMART_NOT_UPDATE', 1);
+    invalidate_user_cache();
+  }
+
+  // create regenerate link
+  $tpl_cat = array();
+  foreach ($smart_cats as $cat => $name)
+  {
+    $tpl_cat[$cat] = $self_url.'&amp;smart_generate='.$cat;
+  }
+  if (count($smart_cats))
+  {
+    $tpl_cat['all'] = $self_url.'&amp;smart_generate=all';
+  }
+
+  $template->assign(array(
+    'SMART_URL' => $tpl_cat,
+    'SMART_PATH' => SMART_PATH,
+  ));
+
+  $template->set_prefilter('categories', 'smart_cat_list_prefilter');
+}
+
+
+function smart_cat_list_prefilter($content)
+{
+  $search[0] = '{if isset($category.U_MANAGE_ELEMENTS) }';
+  $replacement[0] = $search[0].'
+{if isset($SMART_URL[$category.ID])}
+| <a href="{$SMART_URL[$category.ID]}">{\'Regenerate photos list of this SmartAlbum\'|@translate}</a>
+{/if}';
+
+  $search[1] = '<a href="#" id="autoOrderOpen">{\'apply automatic sort order\'|@translate}</a>';
+  $replacement[1] = $search[1].'
+{if isset($SMART_URL.all)}| <a href="{$SMART_URL.all}">{\'Regenerate photos list of all SmartAlbums\'|@translate}</a>{/if}';
+
+  $search[2] = '{$category.NAME}</a></strong>';
+  $replacement[2] = $search[2].'
+{if isset($SMART_URL[$category.ID])}
+<img src="'.SMART_PATH.'admin/template/lightning.png">
+{/if}';
+
+  return str_replace($search, $replacement, $content);
+}
